string PrmContent;
int gsrnCount;

string generateSomeRandomName()
{
    return string("gsrn") + to_string(gsrnCount++);
}

string title(string value)
{
    PrmContent += "title {" + value + "}\n";
    return "";
}

string units(string value)
{
    PrmContent += "units " + value + "\n";
    return "";
}

string arb8
(
 string name,
 double x1, double y1, double z1,
 double x2, double y2, double z2,
 double x3, double y3, double z3,
 double x4, double y4, double z4,
 double x5, double y5, double z5,
 double x6, double y6, double z6,
 double x7, double y7, double z7,
 double x8, double y8, double z8
)
{
    stringstream ss;
    ss << "put {" << name << "} arb8 V1 {" << x1 << " " << y1 << " " << z1
                              << " } V2 {" << x2 << " " << y2 << " " << z2
                              << " } V3 {" << x3 << " " << y3 << " " << z3
                              << " } V4 {" << x4 << " " << y4 << " " << z4
                              << " } V5 {" << x5 << " " << y5 << " " << z5
                              << " } V6 {" << x6 << " " << y6 << " " << z6
                              << " } V7 {" << x7 << " " << y7 << " " << z7
                              << " } V8 {" << x8 << " " << y8 << " " << z8 << "}\n";
    PrmContent += ss.str();
    return name;
}

/*string tgc
(
 string name,
 double vertexx, double vertexy, double vertexz,
 double heightx, double heightx, double heightx,
 double ax, double ay, double az,
 double bx, double by, double bz,
 double cx, double cy, double cz,
 double dx, double dy, double dz
)
{
    stringstream ss;
    ss << "put {" << name << "} tgc V {" << " " << vertexx << " " << vertexy << " " << vertexz
                             << " } H {" << " " << heightx << " " << heightx << " " << heightx
                             << " } A {" << " " << ax << " " << ay << " " << az
                             << " } B {" << " " << bx << " " << by << " " << bz
                             << " } C {" << " " << cx << " " << cy << " " << cz
                             << " } D {" << " " << dx << " " << dy << " " << dz << "}\n";
    PrmContent += ss.str();
    return name;
}*/


string color(string name, int R, int G, int B)
{
    stringstream ss;
    ss << "attr set {" << name << "} {color} {" << R << "/" << G << "/" << B << "}\n";
    PrmContent += ss.str();
    return name;
}
string attrManual(string name, string attrValue)
{
    stringstream ss;
    ss << "attr set {" << name << "}" << attrValue << "}\n";
    PrmContent += ss.str();
    return name;
}

void Manual(string line)
{
    PrmContent += line + "\n";
}

void saveASC(string path)
{
    ofstream fs(path);
    fs << PrmContent;
    fs.close();
}

string combinationsManual(string name, bool region, string tree)
{
    stringstream ss;
    ss << "put {" << name << "} comb region " << (region ? "yes" : "no") << " tree " << tree << "\n";
    PrmContent += ss.str();
    return name;
}
#if 0

#include "primitives.h"

string generateSomeRandomName()
{
    return string("gsrn") + to_string(gsrnCount++);
}

string title(string value)
{
    PrmContent += "title {" + value + "}\n";
    return "";
}

string units(string value)
{
    PrmContent += "units " + value + "\n";
    return "";
}

string arb8
(
 string name,
 double x1, double y1, double z1,
 double x2, double y2, double z2,
 double x3, double y3, double z3,
 double x4, double y4, double z4,
 double x5, double y5, double z5,
 double x6, double y6, double z6,
 double x7, double y7, double z7,
 double x8, double y8, double z8
)
{
    stringstream ss;
    ss << "put {" << name << "} arb8 V1 {" << x1 << " " << y1 << " " << z1
                              << " } V2 {" << x2 << " " << y2 << " " << z2
                              << " } V3 {" << x3 << " " << y3 << " " << z3
                              << " } V4 {" << x4 << " " << y4 << " " << z4
                              << " } V5 {" << x5 << " " << y5 << " " << z5
                              << " } V6 {" << x6 << " " << y6 << " " << z6
                              << " } V7 {" << x7 << " " << y7 << " " << z7
                              << " } V8 {" << x8 << " " << y8 << " " << z8 << "}\n";
    PrmContent += ss.str();
    return name;
}

string color(string name, int R, int G, int B)
{
    stringstream ss;
    ss << "attr set {" << name << "} {color} {" << R << "/" << G << "/" << B << "}\n";
    PrmContent += ss.str();
    return name;
}
string attrManual(string name, string attrValue)
{
    stringstream ss;
    ss << "attr set {" << name << "} " << attrValue << "\n";
    PrmContent += ss.str();
    return name;
}

void Manual(string line)
{
    PrmContent += line + "\n";
}

void saveASC(string path)
{
    ofstream fs(path);
    fs << PrmContent;
    fs.close();
}
#endif
